<?php

/**
 * Script para geracao de chaves de acesso ao HS. A chave gerada varia
 * conforme o horario em que e gerada.
 * 
 * Exemplo:
 * $ php generateSecret.php '{{NOME_ORG}}'
 */

$nomeOrg = $argv[1] ?? null;


if (empty($nomeOrg)) {
    echo 'Informe o Nº de uma org. como parâmetro.';
    return;
}

function genLastKeys($key) {
    $keyLength = strlen($key);
    if (!empty($key) && $keyLength >= 3) {
        $code = round(ord($key[1]) * ord($key[(int)round((($keyLength / 4) * 0.6))]) / ord($key[$keyLength - 3]));
        return ((string)$code % 9) . ((string)$code % 4);
    }
    return null;
}

$secret = hash("md5",$nomeOrg);
$secret = uniqid($secret);

$invalidToken = true;
while ($invalidToken) {
    $lastKeys = genLastKeys($secret);
    if (!empty($lastKeys)) {
        $secret .= $lastKeys;
        $invalidToken = false;
    }
}

echo $secret . PHP_EOL;
