<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class BancoHorasRepository {
    /** @var EntityManager */
    protected $entityManager;

    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->connection = $entityManager->getConnection();
    }

    public function getBancoHorasAdmi(
        int $nrOrg,
        int $nrTipoVinculo
    ): array {
        $sql = <<<SQL
            SELECT
                *
            FROM
                PTO_BANCOHORASADMI
            WHERE
                NRORG = :P_NRORG AND
                NRTIPOVINCULOM = :P_NRTIPOVINCULOM
SQL;

        $params = [
            'P_NRORG'           => $nrOrg,
            'P_NRTIPOVINCULOM'  => $nrTipoVinculo,
        ];

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $result = $std->fetchAll();

        return $result;
    }

    public function setAlteBancoHoras(
        array $params
    ): void {
        $sql = <<<SQL
            INSERT INTO PTO_ALTEBANCOHORAS (
                NRORG,              NRALTEBANCOHORAS,       NRBANCOHORAS,
                NRVINCULOM,         DTINICIOALTEBHORAS,     DTFIMALTEBHORAS,
                IDATIVO,            NRORGINCLUSAO,          DTINCLUSAO,
                CDOPERINCLUSAO,     NRORGULTATU,            DTULTATU,
                CDOPERULTATU
            )
            VALUES (
                :NRORG,             :NRALTEBANCOHORAS,      :NRBANCOHORAS,
                :NRVINCULOM,        :DTINICIOALTEBHORAS,    :DTFIMALTEBHORAS,
                :IDATIVO,           :NRORGINCLUSAO,         :DTINCLUSAO,
                :CDOPERINCLUSAO,    :NRORGULTATU,           :DTULTATU,
                :CDOPERULTATU
            )
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}