<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 04/09/2015
 * Time: 15:40
 */

namespace Service\Hcm;

class EmpresaService {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getEstruturalegalByCnpjAndCompetenciaAndNrorg($cdcnpjestrut, $dtmescompetencia, $nrorg, $cnpjRaiz = null){
        try {
            $query = <<<SQL
SELECT EH.*
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
  JOIN GPE_PARAMORG PO ON PO.NRORG = EM.NRORG
 WHERE EM.NRTIPOESTRUTURA = PO.NRTPESTRUTLEGAL
   AND (EH.CDCNPJESTRUT = :P_CDCNPJESTRUT OR :P_CDCNPJESTRUT IS NULL)
   AND (SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_CDCNPJEMPREGADOR,1,8) OR :P_CDCNPJEMPREGADOR IS NULL)
   AND EM.DTINIVIGENCIA <= LAST_DAY(TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
   AND (EM.DTFIMVIGENCIA IS NULL OR EM.DTFIMVIGENCIA >= TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
   AND EH.NRORG = :P_NRORG
SQL;
            $params = array(
                'P_DTMESCOMPETENC' => $dtmescompetencia,
                'P_CDCNPJESTRUT' => $cdcnpjestrut,
                'P_NRORG' => $nrorg,
               'P_CDCNPJEMPREGADOR' => $cnpjRaiz
            );
            $array = $this->entityManager->getConnection()->fetchAll($query, $params);
            if($cdcnpjestrut == null) {
                return $array;
            }
            return empty($array) ? $array : $array[0];
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getEstruturaLegalSuperior($nrestruturam_rel, $dtmescompetencia, $nrorg){
        try {
            $query = <<<SQL
SELECT EH.*
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= '$dtmescompetencia')
  JOIN GPE_PARAMORG PO ON PO.NRORG = EM.NRORG
 WHERE EM.NRESTRUTURAM = GET_NRESTRUTURA_SUPERIOR(:P_NRORG, :P_NRESTRUTURAM_REL, PO.NRTPESTRUTLEGAL, '$dtmescompetencia')
   AND EM.NRORG = :P_NRORG
SQL;
            $params = array(
                'P_DTMESCOMPETENC' => $dtmescompetencia,
                'P_NRESTRUTURAM_REL' => $nrestruturam_rel,
                'P_NRORG' => $nrorg
            );

            $array = $this->entityManager->getConnection()->fetchAll($query, $params);
            return empty($array) ? $array : $array[0];
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getEstrutura($nrestruturam, $dtmescompetencia, $nrorg){
        try {
            $query = <<<SQL
SELECT EH.*
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= '$dtmescompetencia')
 WHERE EM.NRESTRUTURAM = :P_NRESTRUTURAM
   AND EM.NRORG = :P_NRORG
SQL;
            $params = array(
                'P_NRESTRUTURAM' => $nrestruturam,
                'P_NRORG' => $nrorg
            );

            $array = $this->entityManager->getConnection()->fetchAll($query, $params);
            return empty($array) ? $array : $array[0];
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getEstruturaRelacionadaByFilialAndCentrocusto($nrorg, $dtmescompetencia, $nrestruturamsup, $cdintestrutexpfil, $cdintestrutexp){
        try {
            $query = <<<SQL
SELECT EM.NRTIPOESTRUTURA, EH.*
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
  JOIN HIERARQUIAORG HO ON HO.NRORG = EM.NRORG
                       AND HO.NRESTRUTURAMREL = EM.NRESTRUTURAM
                       AND HO.NRESTRUTURAMSUP = :P_NRESTRUTURAMSUP
 WHERE EM.NRORG = :P_NRORG
   AND EM.CDINTESTRUTEXPFIL = :P_CDINTESTRUTEXPFIL
   AND EM.CDINTESTRUTEXP = :P_CDINTESTRUTEXP
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_DTMESCOMPETENC' => $dtmescompetencia,
                'P_NRESTRUTURAMSUP' => $nrestruturamsup,
                'P_CDINTESTRUTEXPFIL' => $cdintestrutexpfil,
                'P_CDINTESTRUTEXP' => $cdintestrutexp,
            );

            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getEstruturaByCnpjAndTipoestrutura($nrorg, $dtmescompetenc, $cdcnpjestrut, $nrtipoestrutura){
        try {
            $query = <<<SQL
SELECT EM.NRTIPOESTRUTURA, EH.*
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTURA
   AND EH.CDCNPJESTRUT = :P_CDCNPJESTRUT
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_DTMESCOMPETENC' => $dtmescompetenc,
                'P_NRTIPOESTRUTURA' => $nrtipoestrutura,
                'P_CDCNPJESTRUT' => $cdcnpjestrut,
            );

            return $this->entityManager->getConnection()->fetchAssoc($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getEstruturaPorTipo($nrestruturam, $tipo, $dtmescompetencia, $nrorg){
        try {
            $query = <<<SQL
SELECT
    EM.NMESTRUTURAM "name",
    EM.NRESTRUTURAM "code",
    EM.*,
    EH.*
FROM
         ESTRUTURAM EM
    LEFT JOIN ESTRUTURAH EH ON EM.NRESTRUTURAM = EH.NRESTRUTURAM
                          AND EM.NRORG = EH.NRORG
                          AND DTMESCOMPETENC = (
        SELECT
            DTMESCOMPETENC
        FROM
            ESTRUTURAH
        WHERE
                NRORG = EH.NRORG
            AND NRESTRUTURAM = EH.NRESTRUTURAM
            AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
        ORDER BY
            DTMESCOMPETENC DESC
        FETCH FIRST ROW ONLY
    )
    LEFT JOIN GPE_PARAMORG PO ON PO.NRORG = EM.NRORG
WHERE
        EM.NRORG = :P_NRORG
    AND ( :P_NRESTRUTURAM IS NULL
          OR INSTR(','
                   || :P_NRESTRUTURAM
                   || ',', ','
                           || EM.NRESTRUTURAM
                           || ',') > 0 )
    AND (
        CASE
            WHEN :P_TIPO IS NULL THEN 1
            WHEN :P_TIPO = 1 AND EM.NRTIPOESTRUTURA = PO.NRTPESTRUTLEGAL THEN 1 /* 1 - Estrutura legal */
            WHEN :P_TIPO = 2 AND EM.NRTIPOESTRUTURA = PO.NRTPESTRUTGEREN THEN 1 /* 2 - Estrutura Gerencial */
            WHEN :P_TIPO = 3 AND EM.NRTIPOESTRUTURA = 10 THEN 1 /* 3 - Estrutura sindical */
            ELSE 0
        END
    ) = 1
    AND EM.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
    AND ( EM.DTFIMVIGENCIA IS NULL
          OR EM.DTFIMVIGENCIA >= :P_DTMESCOMPETENC )
SQL;
            $params = array(
                'P_NRESTRUTURAM' => $nrestruturam,
                'P_DTMESCOMPETENC' => $dtmescompetencia,
                'P_TIPO' => $tipo,
                'P_NRORG' => $nrorg
            );

            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function addEstruturaMestre($nrorg, $nrestruturam, $nrtipoestrutura, $dtinivigencia, $nmestruturam, $nrparcnegocio, $cdintestrutura, $dsestrutura, 
                                       $cdintestrutexp, $cdintestrutexpfil, $cdcentcust, $dsurllogoestrutura, $nrtpeventoctbl, $cdoperinclusao){
        try {
            $sql = <<<SQL
INSERT INTO ESTRUTURAM
    (NRORG, NRESTRUTURAM, NRTIPOESTRUTURA, DTINIVIGENCIA, NMESTRUTURAM, NRPARCNEGOCIO, CDINTESTRUTURA, DSESTRUTURA, CDINTESTRUTEXP, CDINTESTRUTEXPFIL, CDCENTCUST, DSURLLOGOESTRUTURA, NRTPEVENTOCTBL, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
VALUES 
    (:NRORG, :NRESTRUTURAM, :NRTIPOESTRUTURA, TO_DATE(:DTINIVIGENCIA,'DD/MM/YYYY'), :NMESTRUTURAM, :NRPARCNEGOCIO, :CDINTESTRUTURA, :DSESTRUTURA, :CDINTESTRUTEXP, :CDINTESTRUTEXPFIL, :CDCENTCUST, :DSURLLOGOESTRUTURA, :NRTPEVENTOCTBL, 'S', SYSDATE, 1, :CDOPERINCLUSAO)
SQL;
            $params = array(
                'NRORG' => $nrorg,
                'NRESTRUTURAM' => $nrestruturam,
                'NRTIPOESTRUTURA' => $nrtipoestrutura,
                'DTINIVIGENCIA' => $dtinivigencia,
                'NMESTRUTURAM' => $nmestruturam,
                'NRPARCNEGOCIO' => $nrparcnegocio,
                'CDINTESTRUTURA' => $cdintestrutura,
                'DSESTRUTURA' => $dsestrutura,
                'CDINTESTRUTEXP' => $cdintestrutexp,
                'CDINTESTRUTEXPFIL' => $cdintestrutexpfil,
                'CDCENTCUST' => $cdcentcust,
                'DSURLLOGOESTRUTURA' => $dsurllogoestrutura,
                'NRTPEVENTOCTBL' => $nrtpeventoctbl,
                'CDOPERINCLUSAO' => $cdoperinclusao,
            );
            $result = $this->entityManager->getConnection()->prepare($sql)->execute($params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function addEstruturaHistorico($nrorg, $nrestruturah, $nrestruturam, $dtmescompetenc, $cdcnpjestrut, $cdceiestrut, $nmrazsocestrut, 
                    $cdnatujuri, $cdcnae, $nrcaged, $cdemprcaixa, $idtipoempr, $idoptsimples, $idparticipat, $nrparcnegocio, $nrpropriempr, $nrparcrespinf, $nrparcentisin, 
                    $cdfpas, $nmfantasia, $nmestruturah, $dtbasesindical, $cdsindical, $cdterceiro, $nrclasstribut, $vrfap, $nrtipotribut, 
                    $vraliqdeson, $cdfederalestrut, $nrparcregamb, $nrparcmonbio, $dtiniresamb, $dtfimresamb, $cdoperinclusao){
        try {
            $sql = <<<SQL
INSERT INTO ESTRUTURAH
    (NRORG, NRESTRUTURAH, NRESTRUTURAM, DTMESCOMPETENC, CDCNPJESTRUT, CDCEIESTRUT, NMRAZSOCESTRUT, CDNATUJURI, CDCNAE, NRCAGED, CDEMPRCAIXA, IDTIPOEMPR, IDOPTSIMPLES, IDPARTICIPAT, NRPARCNEGOCIO, NRPROPRIEMPR, NRPARCRESPINF, NRPARCENTISIN, CDFPAS, NMFANTASIA, NMESTRUTURAH, DTBASESINDICAL, CDSINDICAL, CDTERCEIRO, NRCLASSTRIBUT, VRFAP, NRTIPOTRIBUT, VRALIQDESON, CDFEDERALESTRUT, NRPARCREGAMB, NRPARCMONBIO, DTINIRESAMB, DTFIMRESAMB, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
VALUES 
    (:NRORG, :NRESTRUTURAH, :NRESTRUTURAM, TO_DATE(:DTMESCOMPETENC,'DD/MM/YYYY'), :CDCNPJESTRUT, :CDCEIESTRUT, :NMRAZSOCESTRUT, :CDNATUJURI, :CDCNAE, :NRCAGED, :CDEMPRCAIXA, :IDTIPOEMPR, :IDOPTSIMPLES, :IDPARTICIPAT, :NRPARCNEGOCIO, :NRPROPRIEMPR, :NRPARCRESPINF, :NRPARCENTISIN, :CDFPAS, :NMFANTASIA, :NMESTRUTURAH, TO_DATE(:DTBASESINDICAL,'DD/MM/YYYY'), :CDSINDICAL, :CDTERCEIRO, :NRCLASSTRIBUT, :VRFAP, :NRTIPOTRIBUT, :VRALIQDESON, :CDFEDERALESTRUT, :NRPARCREGAMB, :NRPARCMONBIO, TO_DATE(:DTINIRESAMB,'DD/MM/YYYY'), TO_DATE(:DTFIMRESAMB,'DD/MM/YYYY'), 'S', SYSDATE, 1, :CDOPERINCLUSAO)
SQL;
            $params = array(
                'NRORG' => $nrorg,
                'NRESTRUTURAH' => $nrestruturah,
                'NRESTRUTURAM' => $nrestruturam,
                'DTMESCOMPETENC' => $dtmescompetenc,
                'CDCNPJESTRUT' => $cdcnpjestrut,
                'CDCEIESTRUT' => $cdceiestrut,
                'NMRAZSOCESTRUT' => $nmrazsocestrut,
                'CDNATUJURI' => $cdnatujuri,
                'CDCNAE' => $cdcnae,
                'NRCAGED' => $nrcaged,
                'CDEMPRCAIXA' => $cdemprcaixa,
                'IDTIPOEMPR' => $idtipoempr,
                'IDOPTSIMPLES' => $idoptsimples,
                'IDPARTICIPAT' => $idparticipat,
                'NRPARCNEGOCIO' => $nrparcnegocio,
                'NRPROPRIEMPR' => $nrpropriempr,
                'NRPARCRESPINF' => $nrparcrespinf,
                'NRPARCENTISIN' => $nrparcentisin,
                'CDFPAS' => $cdfpas,
                'NMFANTASIA' => $nmfantasia,
                'NMESTRUTURAH' => $nmestruturah,
                'DTBASESINDICAL' => $dtbasesindical,
                'CDSINDICAL' => $cdsindical,
                'CDTERCEIRO' => $cdterceiro,
                'NRCLASSTRIBUT' => $nrclasstribut,
                'VRFAP' => $vrfap,
                'NRTIPOTRIBUT' => $nrtipotribut,
                'VRALIQDESON' => $vraliqdeson,
                'CDFEDERALESTRUT' => $cdfederalestrut,
                'NRPARCREGAMB' => $nrparcregamb,
                'NRPARCMONBIO' => $nrparcmonbio,
                'DTINIRESAMB' => $dtiniresamb,
                'DTFIMRESAMB' => $dtfimresamb,
                'CDOPERINCLUSAO' => $cdoperinclusao,
            );
            $result = $this->entityManager->getConnection()->prepare($sql)->execute($params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

}