<?php
namespace Service\Hcm;

class OcupacaoService {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getCargos($dtmescompetencia, $nrorg) {
        try {
            $query = <<<SQL
SELECT
    OM.NROCUPACAOM "code",
    OH.NMOCUPACAOH "name",
    OH.NMOCUPACAOH "female_name",
    OH.NRCBO       "cbo",
    OH.*,
    OM.*
FROM
    GPE_OCUPACAOM OM
    LEFT JOIN GPE_OCUPACAOH OH ON OM.NROCUPACAOM = OH.NROCUPACAOM
                                  AND OH.NRORG = OM.NRORG
                                  AND OH.DTMESCOMPETENC = (
        SELECT
            MAX(OHH.DTMESCOMPETENC)
        FROM
            GPE_OCUPACAOH OHH
        WHERE
                OHH.NRORG = :P_NRORG
            AND OHH.NROCUPACAOM = OH.NROCUPACAOM
            AND OHH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
    )
WHERE
    ( OM.NRORG = :P_NRORG )
    AND ( DTFIMVIGENCIA >= :P_DTMESCOMPETENC
          OR DTFIMVIGENCIA IS NULL )
SQL;
            $params = array(
                'P_DTMESCOMPETENC' => $dtmescompetencia,
                'P_NRORG' => $nrorg,
            );
            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

}