/* Sistemas Integrados TECNISA

Nome: 9802_CDPTRGO_LOG_CDP_ETAFABRIC.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato
*/

/* Tabela ETAFABRIC.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              ETAFABRIC, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_CDP_ETAFABRIC
AFTER DELETE OR INSERT OR UPDATE
ON ETAFABRIC FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(300);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC   := V_DESC || 'Filial= '       || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF :NEW.CDPRODUTO IS NOT NULL THEN        
         V_DESC   := V_DESC || 'CdProd= '      || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :NEW.CDETAPAPROD IS NOT NULL THEN
         V_DESC   := V_DESC || 'CdEtapaProd= '  || NVL(:NEW.CDETAPAPROD,'') || ' ' ;
         END IF;

         IF :NEW.CDPROCFABRIC IS NOT NULL THEN
         V_DESC   := V_DESC || 'Proporcao= '    || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;
         END IF;

         IF :NEW.CDSETOR IS NOT NULL THEN
         V_DESC   := V_DESC || 'CdSetor= '      || :NEW.CDSETOR || ' ' ;
         END IF;

         IF :NEW.QTHRETFABRIC IS NOT NULL THEN
         V_DESC   := V_DESC || 'QtHrEtapa= ' || TO_CHAR(:NEW.QTHRETFABRIC)  || ' ' ;
         END IF;

         IF :NEW.NRORDETFAB IS NOT NULL THEN
         V_DESC   := V_DESC || 'NrOrdEtFab= '   || :NEW.NRORDETFAB  || ' ' ;
         END IF;

         IF :NEW.IDTPCONCLETAPA IS NOT NULL THEN
         V_DESC   := V_DESC || 'TpoCnclso= '   || :NEW.IDTPCONCLETAPA  || ' ' ;
         END IF;

      V_ITPESQ := :NEW.CDFILIAL || :NEW.CDPRODUTO   || :NEW.CDETAPAPROD || :NEW.CDPROCFABRIC;
                  
      V_IDTIPOOPER := '1';  
      V_CDFILLOGOPER := :NEW.CDFILIAL; 

   ELSE
      IF UPDATING THEN


         IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
            V_DESC   := V_DESC || 'Filial= '       || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN        
         V_DESC   := V_DESC || 'CdProd= '      || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF (:NEW.CDETAPAPROD <> :OLD.CDETAPAPROD) THEN
         V_DESC   := V_DESC || 'CdEtapaProd= '  || NVL(:NEW.CDETAPAPROD,'') || ' ' ;
         END IF;

         IF (:NEW.CDPROCFABRIC <> :OLD.CDPROCFABRIC) THEN
         V_DESC   := V_DESC || 'Proporcao= '    || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;         
         END IF;

         IF (NVL(:NEW.CDSETOR,'-1') <> NVL(:OLD.CDSETOR,'-1')) THEN
         V_DESC   := V_DESC || 'CdSetor= '      || :NEW.CDSETOR || ' ' ;
         END IF;

         IF (:NEW.QTHRETFABRIC <> :OLD.QTHRETFABRIC) THEN
         V_DESC   := V_DESC || 'QtHrEtFabric= ' || TO_CHAR(:NEW.QTHRETFABRIC)  || ' ' ;
         END IF;

         IF (:NEW.NRORDETFAB <> :OLD.NRORDETFAB) THEN
         V_DESC   := V_DESC || 'NrOrdEtFab= '   || :NEW.NRORDETFAB  || ' ' ;
         END IF;

         IF (:NEW.IDTPCONCLETAPA <> :OLD.IDTPCONCLETAPA) THEN
         V_DESC   := V_DESC || 'TpoCnclso= '   || :NEW.IDTPCONCLETAPA  || ' ' ;
         END IF;
 
         V_ITPESQ := :NEW.CDFILIAL || :NEW.CDPRODUTO   || :NEW.CDETAPAPROD || :NEW.CDPROCFABRIC;

             V_IDTIPOOPER := '2';    
             V_CDFILLOGOPER := :NEW.CDFILIAL; 
          
      END IF; 
      IF DELETING  THEN


         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC   := V_DESC || 'Filial= '       || NVL(:OLD.CDFILIAL,'') || ' ' ;
         END IF;

         IF :OLD.CDPRODUTO IS NOT NULL THEN        
         V_DESC   := V_DESC || 'CdProd= '      || NVL(:OLD.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :OLD.CDETAPAPROD IS NOT NULL THEN
         V_DESC   := V_DESC || 'CdEtapaProd= '  || NVL(:OLD.CDETAPAPROD,'') || ' ' ;
         END IF;

         IF :OLD.CDPROCFABRIC IS NOT NULL THEN
         V_DESC   := V_DESC || 'Proporcao= '    || NVL(:OLD.CDPROCFABRIC,'') || ' ' ;         
         END IF;

         IF :OLD.CDSETOR IS NOT NULL THEN
         V_DESC   := V_DESC || 'CdSetor= '      || :OLD.CDSETOR || ' ' ;
         END IF;

         IF :OLD.QTHRETFABRIC IS NOT NULL THEN
         V_DESC   := V_DESC || 'QtHrEtFabric= ' || TO_CHAR(:OLD.QTHRETFABRIC)  || ' ' ;
         END IF;

         IF :OLD.NRORDETFAB IS NOT NULL THEN
         V_DESC   := V_DESC || 'NrOrdEtFab= '   || :OLD.NRORDETFAB  || ' ' ;                          
         END IF;

         IF :OLD.IDTPCONCLETAPA IS NOT NULL THEN
         V_DESC   := V_DESC || 'TpoCnclso= '   || :OLD.IDTPCONCLETAPA  || ' ' ;                          
         END IF;

         V_ITPESQ := :OLD.CDFILIAL || :OLD.CDPRODUTO   || :OLD.CDETAPAPROD || :OLD.CDPROCFABRIC;

         V_IDTIPOOPER := '3';
         V_CDFILLOGOPER := :OLD.CDFILIAL;

      END IF;   
   END IF;

   IF NOT (V_DESC IS NULL) THEN
   
      INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                             DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                   VALUES  ('ETAFABRIC', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                             V_IDTIPOOPER,   V_DESC, V_ITPESQ,
                             V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                             V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER);    
                             
   END IF;                          
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_ETAFABRIC','5.07.001'); END;
/    
